package edu.udo.cs.ie.cowbots.elpParser.dlp;

import edu.udo.cs.ie.cowbots.logic.ELPLiteral;

/**
 * this interface models a logical literal used in
 * disjunctive extended logic programs. 
 * 
 * @author Wei
 * @see {@link DLPNegLiteral}, {@link DLPNotLiteral} and {@link DLPAtom}
 * with the super interface {@link ELPLiteral}
 */
public interface DLPLiteral extends ELPLiteral{
	
	
	/**
	 * returns the atom of this literal
	 * @param b if this literal is a fact or not {@link Boolean}	 * 	
	 */
	public boolean LitIsAfact(boolean b);

	
}
