package edu.udo.cs.ie.cowbots.logic;

/**
 * private class to model arithmetic expressions
 * like "A > B".
 * @author Thomas
 *
 */
class RelationPredicate extends ELPAtom {
	
	public RelationPredicate(String pred, String ...terms) {
		super(pred, terms);
	}
	
	public String toString() {
		return terms[0] + pred + terms[1];
	}
	
	@Override
	public boolean isArithmetic() {
		return true;
	}

	@Override
	public boolean isPredicate() {
		return true;
	}
}