// Agent LEADER in project MAS

/* Initial beliefs and rules */

{include ("walker.asl")}
radiusFaktor(10).
debug.

/* Initial goals */

/* Plans */

+dummyEvent:true
<-
	true.

//Debug system out prints
+!debugPrint(D):	debug 
	<- 	?iam(MyName);
     	.concat("ASL-DEBUG: Agent:",MyName," MSG: ",D,MSG);	
		.print(MSG).
		
+!debugPrint(D): 	not debug
	<-	true.
	
//Maingoal handling	
+!drivencow(Cow):	.my_name(MyName) & time(CurrentTime) 
    				& not rejectedall(drivencow, Cow, Time) 
	<-	!debugPrint("Switched to Leader-Role!");
    	!debugPrint("++++++++++++++++++++++++++++++++++++++++++++");
    	//'finish' the other role goals 
    	.succeed_goal(scouted);
    	//TODO: call scouter abolish plan
	    //!abolishPlan;
    	.succeed_goal(helped(_, _, _));
    	!taskabortHelper;    
    	
    	.concat("Starting multiagenttask for the cow = ",Cow,MsgDriveCow);
		!debugPrint(MsgDriveCow);	
		+drivenObj(Cow);
		
		!multiAgentTask(drivencow,Cow).

+!drivencow(Cow):	.my_name(MyName) 
					& time(CurrentTime) 
    				& rejectedall(drivencow, Cow, Time) 
	<-	!debugPrint("MultiAgentTask couldnt start, rejectedall is still in the BB, CHECK DESIRES");
    	!debugPrint("sleep some time");
    	 skip;
    	.wait(5000).
    	 
    	
//Fail plan for drivenCow    
-!drivencow(Cow):	true
	<-	!debugPrint("DrivenCOW FAILED");
    	!taskabortLeader.

+!multiAgentTask(T,X) : 	cow(X)
	<-	!debugPrint("MultiAgentTask started, follow simultanuasly the cow");
	 	
	   	!!followCow(HelperList, X);
	   	!groupFormed(T,X,HelperList); 	   
	   	   	
	   	!waitTillAgentsArrived(HelperList);
	   	.send(HelperList, tell, allhelpersinrange);
	   	+allhelpersinrange;
	   	!debugPrint("Leader: Agent are there, lets do It! ");	   	
	   	//Task Decomposition   	   
	   	//!taskDecomposition(T, X);	   	   
	   	//stop following the cow
	   	.succeed_goal(followCow(_,_));	   
	   	!tryToDriveTheCow(T, X,HelperList).
	   	//!forEachWP(T, X,HelperList).
// waypoints will be generated every time new, if something goes wrong	   	
+!tryToDriveTheCow(T, Cow,HelperList): restarted
    <- .send(HelperList, tell, tryagainH);
       !debugPrint("Leader: ReStarted driving the cow");
       !taskDecomposition(T, X);
       !forEachWP(T, Cow, HelperList);
       !tryToDriveTheCow(T, Cow,HelperList).
//first start       
+!tryToDriveTheCow(T, Cow,HelperList): not restarted
    <- +restarted;
       !debugPrint("Leader: Started driving the cow");
       !taskDecomposition(T, X);
       !forEachWP(T, Cow, HelperList);
       !tryToDriveTheCow(T, Cow,HelperList).      
 //soft reset.   
    
+tryagainL <- .succeed_goal(forEachWP(_, _, _)).   
	         
//something wrong with wp? just try again.       
-!forEachWP(_, _, _) <- true.
     
          
+!forEachWP(T, Cow, HelperList): 	step(Step) 
                         			& numberOfWaypoints(WayPointsSize) 
                         			& WayPointsSize>Step 
                         			& kwaypoint(WPType,Step,X,Y,FromDirection, ToDirection)
	<-	.concat("Walking to next WP: Step ",Step," Koordinates: x=",X," y=",Y,Msg1);  
       	!debugPrint(Msg1);  	   
	   	!taskAllocation(T, Cow, HelperList); 
	   	?herd(Cow, Radius, _)[source(self)];
	   	?iam(MyName);
	   	.length(HelperList, AgentsCount);
	   
	    //get to position in formation befor rotate.
	    //deactivated 
	    /**
	   	!getMyNextPosition(drivenCow, X, Y, FromDirection, ToDirection, 0, AgentsCount, Radius);
	   	?myNextPositionCoordinates(Xd,Yd);
	   	.concat("Leader: Walking to next WP-vorRotate: x=",Xd," y=",Yd,Msd);
	   	!debugPrint(Msd);
	    
	   	!setWalkingModi(1,0,1);
	   	-walkingfailed; 	
	   	!walkTo(Xd,Yd);  
	     
	   	!debugPrint("Leader: bin an der Position, warte bis alle Agenten auch ihre Positionen eingenommen haben");
	   	!waitForAllAgentsInPosition(AgentsCount, HelperList);  
 	   	*/
 	   	?time(InPosTime);
	   	.send(HelperList, tell, getinformation(Step, InPosTime));
	   	!getMyNextPosition(rotateFormation, X, Y, FromDirection,ToDirection, 0, AgentsCount, Radius);
	   	?myNextPositionCoordinates(Xr,Yr);
	   	
	   	.concat("Leader: Walking to next WP-afterRotate: x=",Xr," y=",Yr,Msr);	   	
	   	!debugPrint(Msr);
	   	!setWalkingModi(1,0,1);
	   	-walkingfailed; 
	    -walkfailscount(_);
        +walkfailscount(0);
	   	!walkTo(Xr,Yr); 	    
	   	
	   	!debugPrint("Leader: Walking to next WP-afterRotate, wait till helpers in their positions");
	   	!waitForAllAgentsInFormation(AgentsCount, HelperList);
	   	//do some strange staff according to waypointtype...	   
	   	!handleWaypointType(WPType,Step,X,Y,FromDirection, ToDirection);
	   
	   	//TODO: look where the cow is
	   	NextStep=Step+1; 
	   	-step(_);
	   	+step(NextStep);
	   	.abolish(inposition(_,_));
	   	.abolish(information(_,_));	   	
	   	!forEachWP(T, Cow,HelperList).
	   	
+!forEachWP(T, Cow, HelperList): 	step(Step) 
                         			& numberOfWaypoints(WayPointsSize) 
                         			& WayPointsSize<=Step                          			
	<-	.concat("Leader: done with waypoints.",Msg1);  
       	!debugPrint(Msg1).  	 	   

//Group formed
+!groupFormed(T, Cow, HelperList): 	true 
	<-	!debugPrint("GroupFormed started");
 		?iam(MyName);
		?time(Wtime);
 		edu.udo.cs.ie.cowbots.planer.getIntensityForLastGoal(MyGoalIntensity);
    	.broadcast(tell, help(T, Cow, MyGoalIntensity, Wtime));
    	//TODO: groupsize calcuating    
    	!calculateGroupSize(MyGoalIntensity, GroupSize);        
    	//GroupSize=2;
    	.concat("Needed Groupsize =",GroupSize,GroupSizeMSG);  
    	!debugPrint(GroupSizeMSG);
    	!waitForGroupFormed(GroupSize, T , Cow, HelperList);
    
    	//sende herd information
    	?time(Time);
    	?radiusFaktor(Faktor);    
    	RadiusUnrounded=MyGoalIntensity * Faktor/100;
    	edu.udo.cs.ie.cowbots.internalActions.math.roundToInt(RadiusUnrounded, Radius);
    	
    	.concat("Radius =", Radius, Debug1);
    	!debugPrint(Debug1);
    	
    	!debugPrint("Send herd information");    
    	.send(HelperList, tell, herd(Cow, Radius, Time));
    	+herd(Cow, Radius, Time).
   
 	

+!calculateGroupSize(MyGoalIntensity, GroupSize):	MyGoalIntensity<60 
	<-	GroupSize=2.
+!calculateGroupSize(MyGoalIntensity, GroupSize):  	MyGoalIntensity>=60 
													& MyGoalIntensity<80
	<-	GroupSize=3.
+!calculateGroupSize(MyGoalIntensity, GroupSize):  	MyGoalIntensity>=80 
	<- 	GroupSize=4.

//wait until group is formed.
+!waitForGroupFormed(GroupSize, T, Cow, HelperList) :  not groupformed(_) 
	<-	!debugPrint("Wait till group formed");
	    skip;
        .wait(5000);     	
		!testGroupFormed(GroupSize,T, Cow, HelperList);
		
		.concat("Group formed, sending groupformed to my Helpers: ",HelperList, Debug1);	
		!debugPrint(Debug1);
		.concat("Groupsize: ",GroupSize, Debug2);
		!debugPrint(Debug2);
				
		?time(GroupFormedTime);
		.my_name(MyName);
		.broadcast(tell, groupformed(T, Cow, GroupFormedTime)).
		          
             
 //reject, group is full
+ack(Agent, T, Cow, Intensity, Time): ally(Agent) &  groupformed(_) 
	<-	!debugPrint("Send rejected , group is full");
		.send(Agent, tell, rejected(T, Cow, Time)).
 
//Are there enough agrees of helper
+!testGroupFormed(GroupSize, T, Cow,  HelperList): 	.count( ack(_,_,_,_)[source(_)],N)
         											&  N >= GroupSize
	<-	.concat("Leader: have got acks: ",N, Debug1);	 
		!debugPrint(Debug1);
		
		.findall(howMuchDoesTheyWant(Agent,GoalIntensity), ack(_, _, GoalIntensity, _)[source(Agent)], AgentsList );
		edu.udo.cs.ie.cowbots.internalActions.Leader.makeAckRejLists(AgentsList,GroupSize,HelperList,RejectedList);
		
		.concat("Leader: HelperList: ", HelperList, Debug2);
		!debugPrint(Debug2);
		.concat("Leader: RejectedList: ", RejectedList, Debug3);
		!debugPrint(Debug3);
		.my_name(MyName);
		?time(Time);
		.send(HelperList,tell,accepted(T, Cow, Time));
		.send(RejectedList,tell,rejected(T, Cow, Time)).
  
//not enough helper
+!testGroupFormed(GroupSize, T ,Cow, HelperList): 	.count( ack(_,_,_,_)[source(_)],N)&
        											N < GroupSize 
	<- 	.concat("Leader: Not enough helper: ", N, Debug);
		!debugPrint(Debug);             
       	!taskabortLeader. 
        

// Task Dekomposition  
+!taskDecomposition(T , X) : true 
  	<-	!debugPrint("--- TaskDekomposition started ---");
  	    //delete old waypoints if exists
   		.abolish(kwaypoint(_,_,_,_,_,_));
   		.my_name(MyName);
		?ison(MyName,X1,Y1,_);
   		.concat("Meine Koordinaten: ",X1," " ,Y1, Debug1);  
   		!debugPrint(Debug1);
		
		//koordinaten vom pferch ermitteln
   		?ison(owncorral, XCorral, YCorral, _);
		
		//koordinaten der Kuh ermitteln
   		?ison(X, XCow, YCow, _); 
   		.concat("Leader: Coords for Taskdecomposition: from ",XCow," ",YCow," to : " , XCorral," ",YCorral," ",Debugmsg);   
   		!debugPrint(Debugmsg);
   		
	    //edu.udo.cs.ie.cowbots.planer.makePlan(driving, X2, Y2, WayPointSize);   
   		//TODO entscheiden was wir nutzen.  
   		!debugPrint("Start create WayPoints: ");
   		edu.udo.cs.ie.cowbots.internalActions.scout.createWaypoints(XCow,YCow,XCorral,YCorral,WayPointsSize);
   		
   		-numberOfWaypoints(_);
   		+numberOfWaypoints(WayPointsSize);
   		.concat("Waypoints count:: ", WayPointsSize, Debug2);
   		!debugPrint(Debug2);
   		Step=0; 
   		-+step(Step).                                                 

-!taskDecomposition(T , X) : true
   <- !debugPrint("--- TaskDekomposition failed, probably the cow isnt there anymore, stop driving---");
      !taskabortLeader. 
// Task Allocation

+!taskAllocation(T, Cow, HelperList) : 	step(Step) 
 											& kwaypoint(WPType,Step,X,Y,FromDirection, ToDirection)  
 	<-	!debugPrint("--- TaskAllocation ---");
       	?time(Time);
        .my_name(MyName);
        .length(HelperList, AgentsCount);
        !sendWpInformation(HelperList, WPType, AgentsCount, MyName, T, Cow, Step, X,Y, FromDirection, ToDirection, 1, AgentsCount, Time).
        
//TODO: fehler behandeln. taskabort? 
-!taskAllocation(_,_,_) :	true
 	<-	!debugPrint("Task Allocation hat nicht geklappt").      
        
+!sendWpInformation(HelperList, WPType, AgentsCount, MyName, T, Cow, Step, X,Y, FromDirection, ToDirection, Formationpos, AgentsCount, Time) 
	: Formationpos<=AgentsCount 
	<-	.concat("sendWPInformation step=",Step," formationposition= ",Formationpos ,Msg1);
        !debugPrint(Msg1);
        
        ListFormation=Formationpos-1;
       	.nth(ListFormation, HelperList, CurrentAgent);
       	
       	.concat("Sende WP an : ",CurrentAgent,Msg2);
       	!debugPrint(Msg2);
 	   	
 	   	.send(CurrentAgent, tell, wp(MyName, WPType, T, Cow, Step, X,Y, FromDirection, ToDirection, Formationpos, AgentsCount, Time));
 	    NextPosition=Formationpos+1;
 	    !sendWpInformation(HelperList, WPType, AgentsCount, MyName, T, Cow, Step, X,Y, FromDirection, ToDirection, NextPosition, AgentsCount, Time).
 	    
+!sendWpInformation(HelperList, WPType, AgentsCount, MyName, T, Cow, Step, X,Y, FromDirection, ToDirection, Formationpos, AgentsCount, Time) 
	: Formationpos>AgentsCount
	<-	!debugPrint("fertig mit WP Information verschicken").
 	        
-sendWpInformation(_,_,_,_,_,_,_,_,_,_,_,_):	true 
 	<-	!debugPrint("sendWpInformation hat nicht geklappt").
        
//keine probleme, keine behandlung :)	          
+!problemSolved(drivenCow(X)): 	true
	<-	true.
 
//Helper in position? We wait for 10 sec. (differenz between leader and helper time
//to get to the final position
+!waitForAllAgentsInPosition(GroupSize, HelperList): 	.count(inposition(_,_),N) 
														& N >= GroupSize
	<-	true.
             
+!waitForAllAgentsInPosition(GroupSize, HelperList):	.count(inposition(_,_),N) 
         												& N < GroupSize
	<-	!debugPrint("Leader: waitForAllAgentsInPosition");
		.wait(10000);
		!waitForAllAgentsInPosition(GroupSize, HelperList).  
  	   
//Helper in formation? We wait for the helper to get in the formation.
+!waitForAllAgentsInFormation(GroupSize, HelperList):	.count(information(_,_),N)
        												& N >= GroupSize
	<- 	true.  
             
+!waitForAllAgentsInFormation(GroupSize, HelperList):	.count(information(_,_),N)
            											& N < GroupSize
	<-	!debugPrint("Leader: waitForAllAgentsInFormation");
		.wait(10000);
		!waitForAllAgentsInFormation(GroupSize, HelperList).
          	
//Spezielle Waypoints behandeln
+!handleWaypointType(WPType,Step,X,Y,FromDirection, ToDirection) : 	WPType = fenceopenwp
	<-	!debugPrint("Hatte einen FenceOpenWP");
		!dooropeningLeading.
 
+!handleWaypointType(WPType,Step,X,Y,FromDirection, ToDirection) : 	WPType = fenceclosewp
	<-	!debugPrint("Hatte einen FenceCloseWP").
	
+!handleWaypointType(WPType,Step,X,Y,FromDirection, ToDirection) : 	WPType = startwp
	<-	!debugPrint("Hatte einen StartWP").

+!handleWaypointType(WPType,Step,X,Y,FromDirection, ToDirection) : 	WPType = endwp
	<-	!debugPrint("Hatte einen EndWP").
	
+!handleWaypointType(WPType,Step,X,Y,FromDirection, ToDirection) : 	true 
	<-	.concat("Hatte einen WP den ich nicht behandelt habe. mit Typ: ", WPType, Msg); 
		!debugPrint(msg).
		 
 	
//Planned Phase
//evtl. einbinden, wenn alles glatt laufen wird

/**
+!planned(T, Obj, GeneratedPlan):	true
	<-	!debugPrint("Planned");
     	?myNextPositionCoordinates(MyNextXCoordinate,MyNextYCoordinate);
 		edu.udo.cs.ie.cowbots.planer.makePlan(T, MyNextXCoordinate, MyNextYCoordinate, Obj, GeneratedPlan).
      	
+!exeMon(GeneratedPlan) : true 
	<-	!debugPrint("GeneratePlan");
     	edu.udo.cs.ie.cowbots.planer.getPlan(GeneratedPlan).
*/
     
 //follow the cow, till helpers arived and in range are 
 //the cow are at needed range, so we can havnt to walk.
 +!followCow(HelperList, Cow):	
                    not allhelpersinrange 
					& cow(Cow) 
					& ison(Cow,X,Y,_)
					& .my_name(MyName) 
					& ison(MyName, Xm, Ym, _)
					& edu.udo.cs.ie.cowbots.internalActions.Leader.followTheCowGently(Xm,Ym,X,Y,Xt,Yt)
					& Xm==Xt
					& Ym==Yt
					
	<-	.concat("Leader: Verfolge die Kuh auf den Koordinaten: x=", X," y=" ,Y," ,no need to walk", Msg1);
		!debugPrint(Msg1);			
		//no need to walk, so skip
		skip;
		!followCow(HelperList, Cow).
            
 //the cow are not at needed range, so we need to walk.
 +!followCow(HelperList, Cow):	
                    not allhelpersinrange 
					& cow(Cow) 
					& ison(Cow,X,Y,_)
					& .my_name(MyName) 
					& ison(MyName, Xm, Ym, _)
					& edu.udo.cs.ie.cowbots.internalActions.Leader.followTheCowGently(Xm,Ym,X,Y,Xt,Yt)
					& (Xm\==Xt | Ym\==Yt)
					
	<-	.concat("Leader: Verfolge die Kuh auf den Koordinaten: x=", X," y=" ,Y, Msg1);
		!debugPrint(Msg1);	
		.concat("Leader: Laufe deswegen zu Koordinaten: x=", Xt," y=" ,Yt, Msg2);
		!debugPrint(Msg2);
		!setWalkingModi(1,0,1);
		-walkingfailed;           
		!walkTo(Xt,Yt);
		.wait(1000);
		!followCow(HelperList, Cow).
           
 //gruppe geformed, kuh ist immer noch im Sichtfeld
 +!followCow(HelperList, Cow) :	allhelpersinrange 
					& cow(Cow) 
					& ison(Cow,X,Y,_) 
	<-	!debugPrint("Cow still there, group formed and all helpers in range").            
  		
//kuh ist abgehauen, kein ison mit der kuh mehr vorhanden    
+!followCow(HelperList, Cow) :	not ison(Cow,X,Y,_) 
	<-	!debugPrint("Cow isnt there anymore, started taskabort");
		!taskabortLeader.

//ToDo: Im Helper das Goal cowMoved implementieren
//		Wartet auf Antwort zum Laufen
//wenn der Leader hinterherläuft muessen die Helfer informiert werden
/**
+!followCowHelper(HelperList, OldX, OldY, NewX, NewY): true
	<-	DeltaX = OldX - NewX;
		DeltyY = OldY - NewY;	
		.concat("Leader: Sende Helfern DeltaX=", DeltaX," DeltaY=" , DeltaY, Debug1);
		!debugPrint(Debug1).
		//.send(HelperList, tell, cowMoved(DeltaX, DeltaY)).
        
 */
            
//helper sends planfail, TODO?
+planfailure(T, Time) : 	true
	<-	!debugPrint(" helper sended planfail.").
                 
//not all helpers are arived
+!waitTillAgentsArrived(HelperList): 	.length(HelperList, HelperListSize) 
      									& .count(iamarrived(_),ArrivedAgents)
      									& ArrivedAgents<HelperListSize
	<-	.concat("Leader: wait till all agents arrived, now are ",ArrivedAgents, " allready arrived.", DbMsg);
		!debugPrint(DbMsg);
		.my_name(MyName);
    	?time(Time);
		?ison(MyName, X, Y, _);		
        .send(HelperList,tell, leaderIsOn(MyName, X, Y, Time));
     	.wait(10000);         	       	
     	!waitTillAgentsArrived(HelperList).
         	
//alle agenten sind da, wir sind fertig mit warten         	
+!waitTillAgentsArrived(HelperList):	.length(HelperList, HelperListSize) 
      									& .count(iamarrived(_),ArrivedAgents)
      									& ArrivedAgents>=HelperListSize
	<-	!debugPrint("Leader: all agents has arrived!").
            
//-!waitTillAgentsArrived(HelperList) : 	true
//	<-	!waitTillAgentsArrived(HelperList). 
           
          
+!taskabortLeader :	drivenObj(Cow)
	<-	.my_name(MyName);
		?time(Time);
	    .concat("Cancel Leaderrole ",MyName," Time= ", Time, Msg); 
        !debugPrint(Msg);    

        .findall(Agent, ack(_, _, _, _)[source(Agent)], AgentsList ); 
        //?drivenObj(Cow);
        .send(AgentsList,tell, rejectedall(drivencow, Cow, Time));        
       
         +rejectedall(drivencow, Cow, Time);
        .abolish(ack(_,_,_,_));
        .abolish(groupformed(_,_,_));
        .abolish(herd(_, _,_));
        .abolish(numberOfWaypoints(_));  
        .abolish(kwaypoint(_,_,_,_,_,_));
        .abolish(myNextPositionCoordinates(_,_));
        .abolish(drivenObj(_));
        .abolish(iamarrived(_));
        .abolish(groupformed(_,_,_,_)[source(MyName)]);
        -allhelpersinrange;
        -restarted;        
        .succeed_goal(waitTillAgentsArrived(_));
        .succeed_goal(followCow(_,_));                                                           
        .succeed_goal(drivencow(_)). 
                                
+!taskabortLeader  :	not drivenObj(_)
	<-	.my_name(MyName);
	    ?time(Time);
	    .concat("Cancel Leaderrole no need to send rej or planfail",MyName," Zeit= ", Time, Msg); 
	    !debugPrint(Msg);  	    
	    .abolish(ack(_,_,_,_));
        .abolish(groupformed(_,_,_));
        .abolish(herd(_, _,_));
        .abolish(numberOfWaypoints(_));  
        .abolish(kwaypoint(_,_,_,_,_,_));
        .abolish(myNextPositionCoordinates(_,_));
        .abolish(drivenObj(_));
        .abolish(iamarrived(_));
        .abolish(groupformed(_,_,_,_)[source(MyName)]);
	    -allhelpersinrange;	    
	    -restarted;
	    .succeed_goal(waitTillAgentsArrived(_));
	    .succeed_goal(followCow(_,_));                                                           
	    .succeed_goal(drivencow(_)).                               
                                
 -!taskabortLeader  :	true
	<-	.concat("Abbruch der Leaderrolle failed",Msg); 
		!debugPrint(Msg).                                     