//Initial beliefs
iAmNotBusy.
{include ("ExAgents/exSharedKnowledge.asl")}
{include ("ExAgents/exWalker.asl")}
{include ("cbfunk.asl")}
{include ("ExAgents/exScoutLeader.asl")}
{include ("ExAgents/exDooropenerLeader.asl")}

// Reconsider after 6 steps
succstepsreconsider(6).

ignoreAlly(1).

+dummyEvent:true
<-
	true.
	
//plan, which invokes a destructor after switching a role
+!drivencow(C): myLastRole(MyRole) & MyRole \== driveCow
<-
    !debugPrint("im in scouted: myLastRole(MyRole) & MyRole unequal driveCow");
    !destruct(MyRole);
    -+myLastRole(driveCow).	
	
+!drivencow(C):not whiledooropening(_)
<-	.print("Starting plan for driving ",C);
	.print("Looking for clock...");
	?time(Q);
	.print("Asking for help...");
	edu.udo.cs.ie.cowbots.planer.getIntensityForLastGoal(I);
	.broadcast(tell, help(drivencow,C,I,Q));
	?iam(N);
	-accepted(_,_,_);
	+accepted(drivencow,C,Q);
	.wait(100);
	?ison(C,X2,Y2,_)[source(percept)];	
	.print("Found cow ",C," on ",X2,",",Y2);
	?corralcenter(CCX,CCY);
	edu.udo.cs.ie.cowbots.planer.makePlan(scouted,X2,Y2,C,A);
	edu.udo.cs.ie.cowbots.planer.makePlan(driving,CCX,CCY,C,B);
	-+waypoints(A + B);
	-+waypointCounter(0);
	.wait(100);
	.print("Looking for wayoint...");
	?kwaypoint(startwp,S,X,Y,F,D);
	.print("Waypoint has target ",X,",",Y);
	edu.udo.cs.ie.cowbots.planer.makePlan(dynamic,X,Y,C); 
	//Ziel ist automatisch owncorral, X,Y unntig
	.print("planned");
	!dynamic;
	.print("sent all WPs");
	edu.udo.cs.ie.cowbots.internalActions.experimental.exEasyFormation(X, Y, 0, D, ExpX, ExpY);
	.print("Start walking to",ExpX,",",ExpY);
	edu.udo.cs.ie.cowbots.planer.makePlan(reach,ExpX,ExpY,N);
	!reach;
	.print("Reached.");
	.wait(100).
	
	
-!drivencow(C):true
<-	.wait(100);
	.print("Stopping drivencow").
	
-!dynamic : true
<- .print("dynamic plan failed").	
	
+!sendWP(Ag,C,Num,Anz): not isBusy(Ag)& not whiledooropening(_)
<- 	.print(Ag," gets a startWP ");
	?kwaypoint(startwp,S,X,Y,F,D);
	?time(Q);
	.send(Ag,tell,waypoint(startwp,drivencow,C,S,X,Y,F,D,Num,Anz,Q)).


+!sendWP(Ag,C,Num,Anz): isBusy(Ag)
<- .print(Ag, " is already busy ");
	.send(Ag,untell,waypoint(_,_,_,_,_,_,_,_,_,_,_)).
	//-isBusy(Ag).
	
-!sendWP(Ag,C,Num,Anz): true
<- .print("sending wps failed").
	
+!help(A,T,C):true
<-
	.print("I'm a leader, I won't help anybody.");
	.wait(1000).
	
-!help(A,T,C):true
<-	.print("Stopping help");
	.wait(1000).
	
@desDC[atomic] +!destruct(driveCow) : true
<-
  !debugPrint("Im destruct(driveCow) : true ");
  !abolishDriveCowPlan.	
  
  
+!abolishDriveCowPlan : true
<- 
   !debugprint("Im in abolishDriveCowPlan : true" );
  .broadcast(untell, help(drivencow,_,_,_));  
  -accepted(_,_,_);
  .abolish(kwaypoint(_,_,_,_,_,_));
  .succeed_goal(walkTo(_,_));
  .succeed_goal(drivencow(_)).