//Initial beliefs

//debug.


//kwaypoint(endwp,4,2,2,northwest,na).
//kwaypoint(fenceclosewp,3,5,5,west,northwest).
//kwaypoint(fenceopenwp,2,9,5,west,west).
//kwaypoint(defaultwp,1,11,5,west,west).
//kwaypoint(startwp,0,12,7,na,southwest).

//kwaypoint(startwp,0,12,7,na,southwest).
//kwaypoint(defaultwp,1,11,6,west,west).
//kwaypoint(defaultwp,1,5,6,west,northwest).
//kwaypoint(endwp,4,2,3,northwest,na).
//wayPoints(4).
//waypointCounter(1).

//scoutDestination(2,5).

//Other Roles
{include ("ExAgents/exSharedKnowledge.asl")}
{include ("ExAgents/exScoutWalker.asl")}
//{include ("ExAgents/exLeader.asl")}
{include ("cbfunk.asl")}




//Dummy event for dummy people 
+dummyEvent:true
<-
	!debugPrint("dummyEvent");
	.wait(100).

//Plans

//plan, which invokes a destructor after switching a role
+!scouted: myLastRole(MyRole) & MyRole \== scout
<-
    !debugPrint("im in scouted: myLastRole(MyRole) & MyRole unequal scout");
    !destruct(MyRole);
    -+myLastRole(scout).



//Main scout leader plan 
+!scouted: true
<- 
    .wait(200);
    !getScoutCandidate.
    
//Check if the leader has arrived at destination
+!getScoutCandidate : wayPoints(T) & waypointCounter(C) & C == T
<-
   !debugPrint("getScoutCandidate : wayPoints(T) & waypointCounter(C) & C > T"); 
  -scoutDestination(_,_);
  .findall(Leader, helper(Leader,_,1), Leaderlist);
  .send(Leaderlist, untell, scoutDestination(_,_));
  -wayPoints(_);
  -waypointCounter(_);
  .abolish(kwaypoint(_,_,_,_,_,_));
  .wait(100).

// If the next WP is a fenceopenwp, then invoke the DoorOpener
+!getScoutCandidate: scoutDestination(_,_)[source(self)] & waypointCounter(WC) & kwaypoint(fenceopenwp,WC,XCOOR, YCOOR, FromDir,ToDir)
<-  
   !debugPrint("getScoutCandidate : scoutDestination(_,_) &  kwaypoint(fenceopenwp,_,_,_,_,_)"); 
   !scoutDoorOpening;
   .wait(100).
      
// If the next WP is a fenceclosewp, then invoke the second DoorOpener-routine
+!getScoutCandidate: scoutDestination(_,_)[source(self)] & waypointCounter(WC) & kwaypoint(fenceclosewp,WC,XCOOR, YCOOR, FromDir,ToDir)
<-
   .print("I arrived at fencecloseWp");
   !scoutDoorClosing;
   .wait(100). 


//Send the current waypoint to helpers
+!getScoutCandidate : scoutDestination(_,_)[source(self)] & waypointCounter(WC) & kwaypoint(TYPE,WC,XCOOR, YCOOR, FromDir,ToDir)
<-
  !debugPrint("getScoutCandidate : scoutDestination(_,_) &  kwaypoint(_,_,_,_,_,_)"); 
  ?iam(NameLeader);
  .findall(HelperName, helper(NameLeader,HelperName,_) & not fenceOpenOutside[source(HelperName)], HelperList);
  .send(HelperList, tell, waypoint(TYPE, scouted, 0, WC, XCOOR, YCOOR, FromDir, ToDir, 0, 0, 0));
  edu.udo.cs.ie.cowbots.internalActions.experimental.exEasyFormation(XCOOR, YCOOR, 0, FromDir, EXXCOOR, EXYCOOR);
  !walkToDest(EXXCOOR, EXYCOOR);
  -+waypointCounter(WC+1);
  .wait(100).

//Generate waypoints for a given scout destination	
+!getScoutCandidate : scoutDestination(_,_)[source(self)] 
<-
  !debugPrint("getScoutCandidate : scoutDestination(_,_) "); 
  !getScoutWaypoints;
  .wait(100).

+!getScoutWaypoints: true
<- !debugPrint("getScoutWaypoints : true "); 
   ?iam(MN);
   ?scoutDestination(X1,Y1)[source(self)];
   edu.udo.cs.ie.cowbots.planer.makePlan(scouted,X1,Y1,MN,T);
   +wayPoints(T);
   -+waypointCounter(1).

-!getScoutWaypoints: true
<- !debugPrint("-!getScoutWaypoints : true "); 
   !abolishScoutedPlan.

//Generate a new scout destination for scouting, if the world is known
+!getScoutCandidate : not scoutDestination(_,_)[source(self)] & worldknown
<-
  !debugPrint("getScoutCandidate : not scoutDestination(_,_) & worldknown ");  
  edu.udo.cs.ie.cowbots.internalActions.scout.getRandomScoutCandidate(X,Y);
  !verifyCandidate(X,Y).

//Generate a new scout destination for scouting
+!getScoutCandidate : not scoutDestination(_,_)[source(self)]
<-
  .wait(10000);
  !debugPrint("getScoutCandidate : not scoutDestination(_,_) ");  
  edu.udo.cs.ie.cowbots.internalActions.scout.getScoutCandidate(X,Y);
  !verifyCandidate(X,Y).

//Verify candidates for destination	   
+!verifyCandidate(X,Y) : true  
<- 
  !debugPrint("Im in: verifyCandidate(X,Y) : true ");  
  .findall(Leader, helper(Leader,_,1), Leaderlist);
  .send(Leaderlist, tell, scoutOption(X,Y));
  +scoutOption(X,Y);
  edu.udo.cs.ie.cowbots.internalActions.scout.checkScoutArea(X,Y,P);
  +areaAccepted(P);
  .wait(100);
  !addDestination(X,Y).
       
//If there is no conflict with other agents candidates, set destination = best candidate       
+!addDestination(X,Y) : areaAccepted(1)
<- 
  !debugPrint("Im in: addDestination(X,Y) : areaAccepted(1)");
  +scoutDestination(X,Y);
  -areaAccepted(1);
  .findall(Leader, helper(Leader,_,1), Leaderlist);
  .send(Leaderlist, untell, scoutOption(X,Y));
  .send(Leaderlist, tell, scoutDestination(X,Y));
  -scoutOption(X,Y);
  .wait(100).
	     
//Ops, there is a conflict, discard candidate	   
+!addDestination(X,Y) : areaAccepted(0)
<-
  !debugPrint("Im in: addDestination(X,Y) : areaAccepted(0)");
  -areaAccepted(0);
  .findall(Leader, helper(Leader,_,1), Leaderlist);
  .send(Leaderlist, untell, scoutOption(X,Y));
  -scoutOption(X,Y);
  .wait(100).

//Procedure for walking     
+!walkToDest(XCOOR,YCOOR) : true
<-
  !debugPrint("walkToDest(XCOOR,YCOOR) : true");
  !scoutWalkTo(XCOOR, YCOOR,1).

//Failure event for plan walkToDest  
-!walkToDest(XCOOR,YCOOR) : true
<-
  !debugPrint("-!walkToDest(XCOOR,YCOOR) : true");
  !abolishScoutedPlanWithoutDest.
  
  
// DoorOpening
+!scoutDoorOpening:   waypointCounter(WC) & kwaypoint(fenceopenwp,WC,XCOOR, YCOOR, FromDir,ToDir) & fenceOpenOutside[source(S)]
<- 
   !debugPrint("+!scoutDoorOpening:   waypointCounter(WC) & kwaypoint(fenceopenwp,WC,XCOOR, YCOOR, FromDir,ToDir)  fenceOpenOutside");
   -+waypointCounter(WC+1);
   -fopsent;
   .wait(100).
   

// preparing to go through the door
+!scoutDoorOpening:   waypointCounter(WC) & kwaypoint(fenceopenwp,WC,XCOOR, YCOOR, FromDir,ToDir) &  fopsent
<-
  !debugPrint("+!scoutDoorOpening:   waypointCounter(WC) & kwaypoint(fenceopenwp,WC,XCOOR, YCOOR, FromDir,ToDir) & fopsent");
  edu.udo.cs.ie.cowbots.internalActions.experimental.exEasyFormation(XCOOR, YCOOR, 0, FromDir, EXXCOOR, EXYCOOR);
  !walkToDest(EXXCOOR, EXYCOOR);
  .wait(100).


// DoorOpening
+!scoutDoorOpening:   waypointCounter(WC) & kwaypoint(fenceopenwp,WC,XCOOR, YCOOR, FromDir,ToDir) & not fopsent
<- 
  !debugPrint("+!scoutDoorOpening:   waypointCounter(WC) & kwaypoint(fenceopenwp,WC,XCOOR, YCOOR, FromDir,ToDir)");
  edu.udo.cs.ie.cowbots.internalActions.scout.getRelevantFence(XCOOR,YCOOR,ToDir,FENCEX,FENCEY);
  !scoutGetSwitch(FENCEX,FENCEY);
  .wait(100).
  
 
//if the switch is found, get it  
+!scoutGetSwitch(FENCEX,FENCEY) : gate(FENCEX,FENCEY,SW,FD)
<- 
  
  !debugPrint("+!scoutGetSwitch(FENCEX,FENCEY) : gate(FENCEX,FENCEY,SW,FD)");
  ?ison(SW,SWX,SWY,_);
  ?waypointCounter(WC);
  ?kwaypoint(_,WC,XCOOR, YCOOR, FromDir2,ToDir2);
  edu.udo.cs.ie.cowbots.internalActions.scout.getOpeningPosition(XCOOR, YCOOR, SWX, SWY, FD,0, TX, TY);
  edu.udo.cs.ie.cowbots.internalActions.scout.getNearestHelper(TX,TY,"none",N);
  .send(N, tell, waypoint(scoutswitchoutside, scouted, 0, WC, TX, TY , 0, 0, 0, 0, 0));
  +interwp(XCOOR,YCOOR);
   ?iam(NameLeader);
  .findall(HelperName, (helper(NameLeader,HelperName,_) & (HelperName \== N)), HelperList);
  .send(HelperList, tell, waypoint(0, scouted, 0, WC, XCOOR, YCOOR, FromDir2, ToDir2, 0, 0, 0));
  -+actualswitch(SWX,SWY,FD);
  +fopsent;
  .wait(100).
   
   
  
  // if the switch isnt found, search for it
+!scoutGetSwitch(FENCEX,FENCEY) : fencegroup(FENCEX,FENCEY,FD)  
 <-  
   !debugPrint("+!scoutGetSwitch(FENCEX,FENCEY) : fencegroup(FENCEX,FENCEY,FD)");
   ?waypointCounter(WC);
   ?kwaypoint(_,WC,XCOOR, YCOOR, FromDir2,ToDir2);
    edu.udo.cs.ie.cowbots.internalActions.scout.getScoutSwitchFinder(XCOOR,YCOOR,FENCEX,FENCEY,FD,Name1,TargetX1, TargetY1, Name2, TargetX2, TargetY2);
   .send(Name1, tell, waypoint(findscoutswitch, scouted, 0, WC, TargetX1, TargetY1 , 0, 0, 0, 0, 0));
   .send(Name2, tell, waypoint(findscoutswitch, scouted, 0, WC, TargetX2, TargetY2 , 0, 0, 0, 0, 0));
   .wait(100).
   
 // if the system needs more time to calculate the gate, wait for it
   +!scoutGetSwitch(FENCEX,FENCEY) : true
   <-
   !debugPrint("+!scoutGetSwitch(FENCEX,FENCEY) : t ");
   .wait(100).

+!checkAgentsOver: allAgentsOver(0) 
<-
  !debugPrint("!allAgentsOver(0) ");
  .wait(100).

+!checkAgentsOver: allAgentsOver(1) 
<-
  !debugPrint("!allAgentsOver(1) ");
  -allAgentsOver(_);
  -awaitingCWP;
  .abolish(fenceOpenInside);
  -fclsent;
  .abolish(fenceOpenOutside);
  -fopsent;
  ?waypointCounter(WC);
  -+waypointCounter(WC+1);
  .wait(100).
  
  
+!scoutDoorClosing: waypointCounter(WC) & kwaypoint(fenceclosewp,WC,XCOOR, YCOOR, FromDir,ToDir) & awaitingCWP
<- !debugPrint("!scoutDoorClosing: awaitingCWP");
   ?fenceOpenInside[source(OS)];
   edu.udo.cs.ie.cowbots.internalActions.scout.checkHelpersNearCWP(XCOOR,YCOOR,OS,R);
   -+allAgentsOver(R);
   !checkAgentsOver;
   .wait(100).
  

+!scoutDoorClosing: waypointCounter(WC) & kwaypoint(fenceclosewp,WC,XCOOR, YCOOR, FromDir,ToDir) & fenceOpenInside[source(S)]
<- !debugPrint("!scoutDoorClosing: waypointCounter(WC) & kwaypoint(fenceclosewp,WC,XCOOR, YCOOR, FromDir,ToDir) & fenceOpenInside[source(S)]");
   ?fenceOpenOutside[source(OS)];
   ?interwp(X,Y);
   .send(OS, tell, interwp(X,Y));
   -interwp(_,_);
   .send(OS, tell, waypoint(fenceclosewp, scouted, 0, WC, XCOOR, YCOOR, FromDir, ToDir, 0, 0, 0));
   +awaitingCWP;
   .wait(100).


+!scoutDoorClosing: waypointCounter(WC) & kwaypoint(fenceclosewp,WC,XCOOR, YCOOR, FromDir,ToDir) & not fclsent
<-
  !debugPrint("!scoutDoorClosing: waypointCounter(WC) & kwaypoint(fenceclosewp,WC,XCOOR, YCOOR, FromDir,ToDir) not fclsent");
  ?actualswitch(SWX,SWY,FD);
  ?fenceOpenOutside[source(S)];
  ?helperison(HX, HY)[source(S)];
  edu.udo.cs.ie.cowbots.internalActions.scout.getOpeningPosition(HX, HY, SWX, SWY, FD,1, TX, TY);
  edu.udo.cs.ie.cowbots.internalActions.scout.getNearestHelper(TX,TY,S,NAME);
  .send(NAME, tell, waypoint(scoutswitchinside, scouted, 0, WC, TX, TY , 0, 0, 0, 0, 0));
  .findall(HelperName, helper(NameLeader,HelperName,_) & HelperName \== NAME & HelperName \== S, HelperList);
  .send(HelperList, tell, waypoint(fenceclosewp, scouted, 0, WC, XCOOR, YCOOR, FromDir, ToDir, 0, 0, 0));
  !walkToDest(XCOOR, YCOOR);
  +fclsent;
  .wait(100).
  
  
 +!scoutDoorClosing: waypointCounter(WC) & kwaypoint(fenceclosewp,WC,XCOOR, YCOOR, FromDir,ToDir) &  fclsent 
 <- 
    !debugPrint("!scoutDoorClosing: waypointCounter(WC) & kwaypoint(fenceclosewp,WC,XCOOR, YCOOR, FromDir,ToDir) fclsent");
    .wait(100).

//Abolish all the beliefs, the plan has failed
+!abolishScoutedPlan : true
<-!debugPrint("Im in:abolishScoutedPlan ");
  .findall(Leader, helper(Leader,_,1), Leaderlist);
  .send(Leaderlist, untell, scoutDestination(_,_));
  .abolish(kwaypoint(_,_,_,_,_,_));
  -scoutDestination(_,_);
  -scoutOption(_,_);
  -waypointCounter(_);
  -wayPoints(_);
  -walkfailscount(_);
  +walkfailscount(0);
  -walkingfailed;
  -allAgentsOver(_);
  -awaitingCWP;
  -fenceOpenInside[source(_)];
  -fclsent;
  -fenceOpenOutside[source(_)];
  -fopsent;
  .abolish(helperOn(_,_)[source(_)]);
  .abolish(helperison(_,_)[source(_)]);
  .succeed_goal(walkToDest(_,_,_));
  .succeed_goal(scouted).

//Abolish all the beliefs beside scoutDestination
+!abolishScoutedPlanWithoutDest : true
<-!debugPrint("ImbolishScoutedPlanWithoutDest : true ");
  .abolish(kwaypoint(_,_,_,_,_,_));
  -scoutOption(_,_);
  -waypointCounter(_);
  -wayPoints(_);
  -walkfailscount(_);
  +walkfailscount(0);
  -walkingfailed;
  -allAgentsOver(_);
  -awaitingCWP;
  -fenceOpenInside[source(_)];
  -fclsent;
  -fenceOpenOutside[source(_)];
  -fopsent;
  .succeed_goal(walkToDest(_,_,_));
  .succeed_goal(scouted).
 

@desSc[atomic] +!destruct(scout) : true
<-
  !debugPrint("Im destructScout : true ");
  !abolishScoutedPlan.

@helper[atomic] +helperOn(X,Y)[source(S)] : true
<-
  !debugPrint("helperon(X,Y)[source(S)]");
  -helperOn(_,_)[source(S)];
  -helperison(_,_)[source(S)];
  +helperison(X,Y)[source(S)].

//Failure event for plan scouted
-!scouted:true
<-
  .print("*************************************************scouted ended mit fehler").