package edu.udo.cs.ie.cowbots.internalActions;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.Term;

public class getExpectedCoordinates extends DefaultInternalAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6418798016322240369L;
	public static String currentPlan;

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {
		int x = (int) ((NumberTerm) args[0]).solve();
		int y = (int) ((NumberTerm) args[1]).solve();
		String action = args[2].toString();
		
		if (action.equals("south")) {
			y++;
	    }else if (action.equals("southwest")){
			x--;y++;
		} else if (action.equals("west")){
			x--;
		}else if (action.equals("northwest")){
			y--;x--;
		} else if (action.equals("north")){
			y--;
		} else if (action.equals("northeast")){
			y--;x++;
		}else if (action.equals("east")) {
			x++;
		} else if (action.equals("southeast")) {
			x++;y++;
		} else {
			System.out.println("ACHTUNG falsche Richtungsangabe");
		}	
		
		un.unifies(args[3], new NumberTermImpl(x));
		un.unifies(args[4], new NumberTermImpl(y));
		return true;
	}

}
