//Initial beliefs
iAmNotBusy.
{include ("ExAgents/exSharedKnowledge.asl")}
{include ("ExAgents/exWalker.asl")}
{include ("cbfunk.asl")}
{include ("ExAgents/exScoutHelper.asl")}
{include ("ExAgents/exDooropenerHelper.asl")}

lasttime(0).
lasthelp(0).

ignoreAlly(1).
lastHelpedWithCow(cow0).
cow(cow0).

// Walker should not reconsider to fast
succstepsreconsider(15).

+dummyEvent:true
<-
	true.
	
+!drivencow(C):true
<-
	.print("I'm to afraid to drive this cow alone...");
	.wait(1000).
	
-!drivencow(C):true
<-	.print("Stopping drivencow").
	
+!helped(A,T,C): myLastRole(MR) & MR \== helper
<-
    !debugPrint("im in scouted: myLastRole MR & MR unequal helper");
    !destruct(MR);
    -+myLastRole(helper).
	
+!helped(A,T,C):true
<-	.print("Helping ",A," with ",T," on ",C);
	
	// BUG WEGEN GOALWECHSEL ?waypoint(startwp,drivencow,C,_,X,Y,_,D,P,_,_)[source(_)];
	?waypoint(startwp,drivencow,_,_,X,Y,_,D,P,_,_)[source(_)];
	edu.udo.cs.ie.cowbots.internalActions.experimental.exEasyFormation(X, Y, P, D, ExpX, ExpY);
	.print("Start walking to ",ExpX,",",ExpY);
	-walkingfailed;
	-walkfailscount(_);
	+walkfailscount(0);
	-stepcount(_);
    +stepcount(0);
	!walkTo(ExpX,ExpY,D);
	.print("Reached.");
	// Try to fix, that loop of this plan ignores everything else
	-waypoint(startwp,drivencow,_,_,_,_,_,_,_,_,Q)[source(_)];
	.wait(100).
	
-!helped(A,T,C):true
<-	.print("Stopping help");
	skip.
	
+waypoint(startwp,drivencow,C,_,_,_,_,_,_,_,N):true
<-	.print("Got new waypoint for driving cow ",C);
	?lasttime(Q);
	-waypoint(startwp,drivencow,_,_,_,_,_,_,_,_,Q)[source(_)];
	-lasttime(Q);
	+lasttime(N);
	.succeed_goal(help(_,_,_));
//	.succeed_goal(walkTo(_,_));
	.wait(100).
	
+help(drivencow,C,_,N):true
<-	?lasthelp(Q);
	?time(T);
	?lastHelpedWithCow(O);
	// Accept new help request
    -accepted(_,_,_)[source(eve)];
	+accepted(drivencow,C,T)[source(eve)];
	// Remember new help request
	-help(drivencow,O,_,Q)[source(_)];
	-lasthelp(Q);
	+lasthelp(N);
	-lastHelpedWithCow(O);
	+lastHelpedWithCow(C);
	// Quit old plan
	.succeed_goal(helped(_,drivencow,O));
	.succeed_goal(walkTo(_,_));
	.wait(100).
	
	
@desDC[atomic]	+!destruct(helper) : true
	<- 
	!debugPrint("im in +!destruct(helper) : true");
	-+lasttime(0);
		-+lasthelp(0);
		-walkfailscount(_);
	+walkfailscount(0);
	-stepcount(_);
    +stepcount(0);
	-accepted(_,_,_)[source(_)];	
	.abolish(waypoint(_,_,_,_,_,_,_,_,_,_,_));
	.succeed_goal(walkTo(_,_));
	.succeed_goal(helped).
	